package org.gemoc.execution.sequential.javaengine.ui.debug;

import com.google.common.base.Objects;
import fr.inria.diverse.trace.api.ITraceManager;
import fr.inria.diverse.trace.api.IValueTrace;
import fr.inria.diverse.trace.gemoc.traceaddon.WrapperSimpleTimeLine;
import java.util.List;
import org.gemoc.execution.sequential.javaengine.ui.debug.OmniscientGenericSequentialModelDebugger;

@SuppressWarnings("all")
public class WrapperOmniscientDebugTimeLine extends WrapperSimpleTimeLine {
  private OmniscientGenericSequentialModelDebugger debugger;
  
  public WrapperOmniscientDebugTimeLine(final ITraceManager manager) {
    super(manager);
  }
  
  public WrapperOmniscientDebugTimeLine(final OmniscientGenericSequentialModelDebugger debugger) {
    super(null);
    this.debugger = debugger;
  }
  
  @Override
  public void notifyTimeLine() {
    boolean _notEquals = (!Objects.equal(this.traceManager, null));
    if (_notEquals) {
      int _currentStateIndex = this.debugger.getCurrentStateIndex();
      int _traceSize = this.traceManager.getTraceSize();
      this.notifyEndChanged(_currentStateIndex, _traceSize);
    }
  }
  
  public boolean isInReplayMode() {
    return this.debugger.isInReplayMode();
  }
  
  @Override
  public int getSelectedPossibleStep(final int branch, final int index) {
    if ((branch == 0)) {
      return this.debugger.getCurrentStateIndex();
    } else {
      List<IValueTrace> _allValueTraces = this.getAllValueTraces();
      final IValueTrace trace = _allValueTraces.get((branch - 1));
      int _currentStateIndex = this.debugger.getCurrentStateIndex();
      final int traceCurrentIndex = trace.getActiveValueIndex(_currentStateIndex);
      if ((traceCurrentIndex == index)) {
        return (-1);
      } else {
        return 0;
      }
    }
  }
}
